## stopt 4.2%2Bdfsg1

=== CMakeLists.txt ===
# vim: set sw=2 ts=2 sts=2:
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

PROJECT(LIBRARY_STOPT CXX C)


# define StOpt versions
SET(STOPT_MAJOR_VERSION 4)
SET(STOPT_MINOR_VERSION 2)
ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")

SET(CMAKE_MODULE_PATH "${LIBRARY_STOPT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")
SET(CMAKE_MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

IF(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# option for PYTHON
OPTION(BUILD_PYTHON "Build python bindings" ON)

# option for MPI
OPTION(BUILD_MPI "Build MPI test" ON)

# option for SDDP 
OPTION(BUILD_SDDP "Build SDDP test" OFF)

# option for DP for Cuts
OPTION(BUILD_DPCUTS "Build DP CUTS test" OFF)

OPTION(BUILD_CPACK "Build for CPACK" OFF)

# option for branching
OPTION(BUILD_BRANCHING "Build Branching test" OFF)
IF (BUILD_BRANCHING)
  IF (NOT BUILD_MPI)
    MESSAGE(FATAL_ERROR "MPI should be on for Branching")
  ENDIF()
  FIND_PACKAGE(Trng4 REQUIRED)
  INCLUDE_DIRECTORIES(SYSTEM ${TRNG4_INCLUDE_DIRS})
ENDIF()

#option for building test
OPTION(BUILD_TEST "Build test " ON)

#option for testing long test cases
OPTION(BUILD_LONG_TEST "Add long tests to the testing module" OFF)
IF(BUILD_LONG_TEST)
  ADD_DEFINITIONS(-DUSE_LONG_TEST)
ENDIF(BUILD_LONG_TEST)

# Boost
ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
IF(BUILD_TEST)
  FIND_PACKAGE(Boost COMPONENTS unit_test_framework  system  timer chrono log thread  REQUIRED)
ENDIF()
MESSAGE(STATUS "Boost unit_test_framework: ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}")
FIND_PACKAGE(Boost COMPONENTS  random REQUIRED)
find_package (Threads REQUIRED)
FIND_PACKAGE(Boost COMPONENTS serialization REQUIRED)
MESSAGE(STATUS "Boost serialization : ${Boost_SERIALIZATION_LIBRARY}")
INCLUDE_DIRECTORIES(SYSTEM ${Boost_INCLUDE_DIRS})
IF(BUILD_MPI)
  FIND_PACKAGE(MPI)
  IF(NOT MPI_CXX_FOUND)
    SET(BUILD_MPI OFF)
  ELSE()
    FIND_PACKAGE(Boost COMPONENTS mpi )
    IF(Boost_MPI_FOUND)
      MESSAGE(STATUS "Boost mpi: ${Boost_MPI_LIBRARY}")
    ENDIF(Boost_MPI_FOUND)
    IF(Boost_MPI_FOUND)
      INCLUDE_DIRECTORIES(SYSTEM ${MPI_CXX_INCLUDE_PATH})
      ADD_DEFINITIONS(-DUSE_MPI)
    ELSE()
      MESSAGE(STATUS "Boost modules mpi  not found. Set BUILD_MPI=OFF")
      SET(BUILD_MPI OFF)
    ENDIF(Boost_MPI_FOUND)
  ENDIF(NOT MPI_CXX_FOUND)
ENDIF(BUILD_MPI)

IF (WIN32)
  #zlib
  FIND_PACKAGE(ZLIB REQUIRED)
 
  #bzip2
  FIND_PACKAGE(BZip2 REQUIRED)
ENDIF(WIN32)

#Eigen
FIND_PACKAGE(Eigen3 REQUIRED)
INCLUDE_DIRECTORIES(SYSTEM ${EIGEN3_INCLUDE_DIR})
# Add some extra delete[] and new[] operatros needed by boost to Eigen::PlainObjectBase
IF (APPLE)
  ADD_DEFINITIONS(-DEIGEN_PLAINOBJECTBASE_PLUGIN="StOpt/core/utils/eigenMemory.h")
ENDIF(APPLE)


INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

IF (NOT MSVC)
 # Detect if the compiler supports C+11
 INCLUDE(CheckCXXCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
 IF(COMPILER_SUPPORTS_CXX14)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
 ELSEIF(COMPILER_SUPPORTS_CXX11)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 ELSEIF(COMPILER_SUPPORTS_CXX0X)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 ELSE()
  MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
 ENDIF()
 SET(PTHREAD_LIBRARY "-lpthread")
ELSE()
  IF(MSVC_VERSION LESS 1800)
    MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no decent C++11 support. Please use a different C++ compiler.")
  ENDIF()
  ADD_COMPILE_OPTIONS(/bigobj)
ENDIF(NOT MSVC)

# Update flags according to the compiler
IF (${CMAKE_CXX_COMPILER_ID} MATCHES Clang)
   IF (APPLE)
     SET(CLANG_SANITIZE_FLAGS "")
  ELSE(APPLE)
     #SET(CLANG_SANITIZE_FLAGS " -fsanitize=undefined-trap,memory -fsanitize-memory-track-origins  -fno-omit-frame-pointer ")
     #SET(CLANG_SANITIZE_FLAGS " -fsanitize=undefined-trap  -fno-omit-frame-pointer ")
     SET(CLANG_SANITIZE_FLAGS "")
  ENDIF(APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -g -O0 ${CLANG_SANITIZE_FLAGS}")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fPIC -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fPIC -O2 -DNDEBUG -g  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra -Wfloat-equal -Wno-system-headers ")
ELSEIF (${CMAKE_CXX_COMPILER_ID} MATCHES GNU)
  IF (APPLE)
    SET(GCC_SANITIZE_FLAGS "")
  ELSE(APPLE)
    SET(GCC_SANITIZE_FLAGS "")
  ENDIF(APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -g -O0 ")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-long-long -Winit-self -Wfloat-equal -Wsign-compare -pedantic -funroll-all-loops -ffast-math -fno-strict-aliasing -ftree-vectorize  -fPIC")
ELSEIF(${CMAKE_CXX_COMPILER_ID} MATCHES Intel)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fpic -O1 -g -ftrapuv")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fpic -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fpic -O2 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
ENDIF()

# Find OpenMP
FIND_PACKAGE(OpenMP)


# SERIALIZATION WITH RANDOM ACCESS
ADD_SUBDIRECTORY(geners-1.11.0)
SET(GENERS_LIB  geners)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/geners-1.11.0)


# Compile library for C++
INCLUDE_DIRECTORIES(SYSTEM ${PROJECT_SOURCE_DIR} ${Boost_INCLUDE_DIRS})
SET(SOURCE_DIR_LIB1 ${PROJECT_SOURCE_DIR}/StOpt/regression)
SET(SOURCE_DIR_LIB2 ${PROJECT_SOURCE_DIR}/StOpt/core/utils)
SET(SOURCE_DIR_LIB3 ${PROJECT_SOURCE_DIR}/StOpt/sddp)
SET(SOURCE_DIR_LIB4 ${PROJECT_SOURCE_DIR}/StOpt/core/sparse)
SET(SOURCE_DIR_LIB5 ${PROJECT_SOURCE_DIR}/StOpt/core/grids)
SET(SOURCE_DIR_LIB6 ${PROJECT_SOURCE_DIR}/StOpt/semilagrangien)
SET(SOURCE_DIR_LIB7 ${PROJECT_SOURCE_DIR}/StOpt/dp)
SET(SOURCE_DIR_LIB8 ${PROJECT_SOURCE_DIR}/StOpt/core/parallelism)
SET(SOURCE_DIR_LIB9 ${PROJECT_SOURCE_DIR}/StOpt/tree)
SET(SOURCE_DIR_LIB10 ${PROJECT_SOURCE_DIR}/StOpt/cdf)
FILE(GLOB SOURCE  ${SOURCE_DIR_LIB1}/*.cpp ${SOURCE_DIR_LIB2}/*.cpp  ${SOURCE_DIR_LIB3}/*.cpp  ${SOURCE_DIR_LIB4}/*.cpp   ${SOURCE_DIR_LIB5}/*.cpp  ${SOURCE_DIR_LIB6}/*.cpp ${SOURCE_DIR_LIB7}/*.cpp  ${SOURCE_DIR_LIB8}/*.cpp ${SOURCE_DIR_LIB9}/*.cpp ${SOURCE_DIR_LIB10}/*.cpp  )
IF (WIN32)
  SET(SUFF "/Release")
  SET(EXTENSION ".exe")
  ADD_LIBRARY(StOpt STATIC ${SOURCE})
ELSE()
   ADD_LIBRARY(StOpt SHARED ${SOURCE})
ENDIF()
IF(BUILD_MPI)
  TARGET_LINK_LIBRARIES(StOpt ${MPI_CXX_LIBRARIES} ${MPI_C_LIBRARIES}    ${Boost_CHRONO_LIBRARY}  ${Boost_SYSTEM_LIBRARY} ${Boost_TIMER_LIBRARY}  ${Boost_MPI_LIBRARY}  ${Boost_SERIALIZATION_LIBRARY} ${GENERS_LIB} ${Boost_RANDOM_LIBRARY}  ${Boost_LOG_LIBRARY}  ${BZIP2_LIBRARIES}  ${ZLIB_LIBRARIES})
ELSE()
  TARGET_LINK_LIBRARIES(StOpt     ${Boost_CHRONO_LIBRARY}  ${Boost_SYSTEM_LIBRARY} ${Boost_TIMER_LIBRARY}  ${Boost_SERIALIZATION_LIBRARY} ${GENERS_LIB} ${Boost_RANDOM_LIBRARY} ${Boost_LOG_LIBRARY} ${BZIP2_LIBRARIES}  ${ZLIB_LIBRARIES} )
ENDIF()
IF(OPENMP_CXX_FOUND)
   TARGET_LINK_LIBRARIES(StOpt OpenMP::OpenMP_CXX)
ENDIF(OPENMP_CXX_FOUND)
SET (STOPT_LIB StOpt)
#install lib
INSTALL(TARGETS StOpt COMPONENT libraries DESTINATION "lib")
# install headers
INSTALL(DIRECTORY StOpt
    COMPONENT headers
    DESTINATION "include"
    FILES_MATCHING
    PATTERN "*.h"
    ${INSTALL_PERMISSIONS_SRC}
  )


INSTALL(DIRECTORY doc
    DESTINATION "doc"
    FILES_MATCHING
    PATTERN "*.pdf"
    ${INSTALL_PERMISSIONS_SRC}
    )

IF(BUILD_PYTHON)
    
  # Python
  FIND_PACKAGE(PythonInterp REQUIRED)
  FIND_PACKAGE(PythonLibsNew REQUIRED)
  MESSAGE(STATUS "Python: ${PYTHON_INCLUDE_DIRS}")
  INCLUDE_DIRECTORIES(SYSTEM ${PYTHON_INCLUDE_DIRS})
  # find pybind
  find_package(PyBind11 REQUIRED)

  # Numpy
  FIND_PACKAGE(NumPy REQUIRED)
  INCLUDE_DIRECTORIES(SYSTEM ${NUMPY_INCLUDE_DIRS})
  SET(SOURCE_PYTHON ${PROJECT_SOURCE_DIR}/StOpt/python)
  IF(CMAKE_SYSTEM_NAME MATCHES "Windows")
    SET(PYTHON_SUFFIX ".pyd")
  ELSEIF(UNIX)
    # Python modules must end .so under Mac 
    SET(PYTHON_SUFFIX ".so")
  ENDIF()
  
  IF (APPLE)

      ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION"  LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptTree  SHARED  ${SOURCE_PYTHON}/Pybind11StOptTree.cpp)
      TARGET_LINK_LIBRARIES(StOptTree  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptTree  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptGeners  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGeners.cpp)
      TARGET_LINK_LIBRARIES(StOptGeners  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptGeners  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptGlobal  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGlobal.cpp)
      TARGET_LINK_LIBRARIES(StOptGlobal  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptGlobal  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptCDF  SHARED  ${SOURCE_PYTHON}/Pybind11StOptCDF.cpp)
      TARGET_LINK_LIBRARIES(StOptCDF  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptCDF  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")
  
    ELSE()
      
      ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${PYTHON_LIBRARIES})
      SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")

      ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${PYTHON_LIBRARIES})
      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")

      ADD_LIBRARY(StOptTree  SHARED  ${SOURCE_PYTHON}/Pybind11StOptTree.cpp)

## stopt 4.2+dfsg1

=== debian/changelog ===
stopt (4.2+dfsg1-3) unstable; urgency=medium

  [ Pierre Gruet ]
  * Marking doc and examples packages as Multi-Arch: foreign
  * Handling some tests differently due to precision issues on i386 and ppc64el

  [ Nilesh Patra ]
  * Add d/salsa-ci.yml

 -- Pierre Gruet <pgt@debian.org>  Tue, 15 Feb 2022 22:17:44 +0100

stopt (4.2+dfsg1-2) unstable; urgency=medium

  * Source-only upload
  * Adding g++ as a dependency of the autopkgtest

 -- Pierre Gruet <pgt@debian.org>  Sun, 13 Feb 2022 07:54:16 +0100

stopt (4.2+dfsg1-1) unstable; urgency=medium

  * Initial release (Closes: #1001099)

 -- Pierre Gruet <pgt@debian.org>  Tue, 07 Dec 2021 14:49:08 +0100

=== debian/control ===
Source: stopt
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>,
           Xavier Warin <xavier.warin@gmail.com>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               coinor-libcoinutils-dev,
               coinor-libosi-dev,
               coinor-libclp-dev,
               dh-python,
               libboost-chrono-dev,
               libboost-log-dev,
               libboost-mpi-dev,
               libboost-random-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libboost-timer-dev,
               libeigen3-dev,
               libopenmpi-dev,
               libgeners-dev,
               pybind11-dev,
               python3-all-dev,
               python3-docutils,
               python3-numpy,
               texlive-fonts-extra <!nodoc>,
               texlive-latex-recommended <!nodoc>,
               texlive-plain-generic <!nodoc>,
               texlive-pstricks <!nodoc>,
               texlive-science <!nodoc>
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/math-team/stopt
Vcs-Git: https://salsa.debian.org/math-team/stopt.git
Homepage: https://gitlab.com/stochastic-control/StOpt/
Rules-Requires-Root: no

Package: libstopt4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: stopt-doc (= ${binary:Version})
Description: library for stochastic optimization problems (shared library)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Different methods are available:
  - dynamic programming methods based on Monte Carlo with regressions (global,
  local, kernel and sparse regressors), for underlying states following some
  uncontrolled Stochastic Differential Equations;
  - dynamic programming with a representation of uncertainties with a tree:
  transition problems are here solved by some discretizations of the commands,
  resolution of LP with cut representation of the Bellman values;
  - Semi-Lagrangian methods for Hamilton Jacobi Bellman general equations for
  underlying states following some controlled Stochastic Differential
  Equations;
  - Stochastic Dual Dynamic Programming methods to deal with stochastic stock
  management problems in high dimension. Uncertainties can be given by Monte
  Carlo and can be represented by a state with a finite number of values
  (tree);
  - Some branching nesting methods to solve very high dimensional non linear
  PDEs and some appearing in HJB problems. Besides some methods are provided
  to solve by Monte Carlo some problems where the underlying stochastic state
  is controlled.
  For each method, a framework is provided to optimize the problem and then
  simulate it out of the sample using the optimal commands previously computed.
  Parallelization methods based on OpenMP and MPI are provided in this
  framework permitting to solve high dimensional problems on clusters.
 The library should be flexible enough to be used at different levels depending
 on the user's willingness.
 .
 This package contains the shared libraries: one which allows for
 multithreading (libstopt-mpi) and one which does not (libstopt).

Package: libstopt-dev
Architecture: any
Section: libdevel
Depends: libstopt4 (= ${binary:Version}),
         coinor-libcoinutils-dev,
         coinor-libosi-dev,
         coinor-libclp-dev,
         libboost-chrono-dev,
         libboost-log-dev,
         libboost-mpi-dev,
         libboost-random-dev,
         libboost-serialization-dev,
         libboost-system-dev,
         libboost-test-dev,
         libboost-thread-dev,
         libboost-timer-dev,
         libeigen3-dev,
         libgeners-dev,
         libopenmpi-dev,
         ${misc:Depends}
Suggests: stopt-doc (= ${binary:Version})
Description: library for stochastic optimization problems (development package)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Different methods are available:
  - dynamic programming methods based on Monte Carlo with regressions (global,
  local, kernel and sparse regressors), for underlying states following some
  uncontrolled Stochastic Differential Equations;
  - dynamic programming with a representation of uncertainties with a tree:
  transition problems are here solved by some discretizations of the commands,
  resolution of LP with cut representation of the Bellman values;
  - Semi-Lagrangian methods for Hamilton Jacobi Bellman general equations for
  underlying states following some controlled Stochastic Differential
  Equations;
  - Stochastic Dual Dynamic Programming methods to deal with stochastic stock
  management problems in high dimension. Uncertainties can be given by Monte
  Carlo and can be represented by a state with a finite number of values
  (tree);
  - Some branching nesting methods to solve very high dimensional non linear
  PDEs and some appearing in HJB problems. Besides some methods are provided
  to solve by Monte Carlo some problems where the underlying stochastic state
  is controlled.
  For each method, a framework is provided to optimize the problem and then
  simulate it out of the sample using the optimal commands previously computed.
  Parallelization methods based on OpenMP and MPI are provided in this
  framework permitting to solve high dimensional problems on clusters.
 The library should be flexible enough to be used at different levels depending
 on the user's willingness.
 .
 This package contains the headers and the static libraries (libstopt-mpi
 which allows for multithreading, and libstopt which does not).

Package: stopt-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: g++,
          libstopt-dev,
          python3-numpy,
          python3-stopt
Enhances: libstopt-dev,
          python3-stopt
Multi-Arch: foreign
Description: library for stochastic optimization problems (programs examples)
 This package provides some programs written to solve mathematical problems
 using the StOpt library. The source code is provided, examples are available
 in C++ and in Python. C++ source code has to be built against the libstopt-dev
 package if one wants to run it.

Package: python3-stopt
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Provides: ${python3:Provides}
Description: library for stochastic optimization problems (Python 3 bindings)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Python 3 bindings are provided by this package in order to allow one
 to use the C++ library in a Python code.

Package: stopt-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libstopt4 (= ${binary:Version}),
          libstopt-dev (= ${binary:Version}),
          stopt-examples (= ${binary:Version}),
          python3-stopt (= ${binary:Version})
Multi-Arch: foreign
Description: library for stochastic optimization problems (documentation)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Python 3 bindings are also provided in order to allow one to use the
 C++ library in a Python code.
 .
 This package contains the documentation about the type of problems that can be
 solved, the mathematical framework, its implementation, and the examples.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND=-O3
export DEB_CXXFLAGS_MAINT_STRIP=-O2
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SOVERSION_STOPT=4
VERSION_STOPT=4.2

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
	        -DCMAKE_INSTALL_PREFIX="/usr" \
	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
	        -DVERSION_STOPT="$(VERSION_STOPT)" \

override_dh_installdocs:
	dh_installdocs
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# Building the latex documentation and installing it.
	# Two sets of paths have to be changed because we used a MUT package.
	cd texdoc && \
	        sed -i 's|../StOpt/StOpt/|../StOpt/|g' documentation.tex && \
	        sed -i 's|../StOpt/test/|../test/|g' documentation.tex && \
	        pdflatex documentation.tex && \
	        bibtex documentation.aux && \
	        pdflatex documentation.tex && \
	        pdflatex documentation.tex
	mkdir -p debian/stopt-doc/usr/share/doc/stopt-doc/
	cp texdoc/documentation.pdf debian/stopt-doc/usr/share/doc/stopt-doc/
endif

override_dh_installexamples:
	dh_installexamples
	cp -a test/python/ debian/stopt-examples/usr/share/doc/stopt-examples/examples/
	# Some Python tests cannot be run because we don't package all built .so...
	# some of them being designed for the tests only.
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/functional/
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/geners/testSomeBinaryArchiveStorage.py
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/global
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/sddp
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/tree

override_dh_fixperms:
	dh_fixperms
	# Manually setting permissions to 644 for source code provided as example
	chmod 644 debian/stopt-examples/usr/share/doc/stopt-examples/examples/c++/python/AR1Wrap.h
	chmod 644 debian/stopt-examples/usr/share/doc/stopt-examples/examples/c++/python/Pybind11SDDPOptimizers.cpp
	chmod 644 debian/stopt-examples/usr/share/doc/stopt-examples/examples/c++/python/Pybind11SDDPSimulators.cpp
	#Setting all Python scripts (that are shipped as examples) as being executable
	for F in $$(find debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/ -name "test*.py"); do \
	        chmod a+x $$F; \
	done

## stopt 5.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # vim: set sw=2 ts=2 sts=2:
-CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.12)
 
 PROJECT(LIBRARY_STOPT CXX C)
 
 
 # define StOpt versions
-SET(STOPT_MAJOR_VERSION 4)
-SET(STOPT_MINOR_VERSION 2)
+SET(STOPT_MAJOR_VERSION 5)
+SET(STOPT_MINOR_VERSION 0)
 ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
 ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")
 
@@ -213,16 +213,15 @@
 IF(BUILD_PYTHON)
     
   # Python
-  FIND_PACKAGE(PythonInterp REQUIRED)
-  FIND_PACKAGE(PythonLibsNew REQUIRED)
-  MESSAGE(STATUS "Python: ${PYTHON_INCLUDE_DIRS}")
-  INCLUDE_DIRECTORIES(SYSTEM ${PYTHON_INCLUDE_DIRS})
+  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development NumPy)
+  INCLUDE_DIRECTORIES(SYSTEM ${Python_INCLUDE_DIRS})
+  MESSAGE(STATUS "Python: ${Python_INCLUDE_DIRS}")
+
   # find pybind
   find_package(PyBind11 REQUIRED)
 
   # Numpy
-  FIND_PACKAGE(NumPy REQUIRED)
-  INCLUDE_DIRECTORIES(SYSTEM ${NUMPY_INCLUDE_DIRS})
+  INCLUDE_DIRECTORIES(SYSTEM ${Python3_NumPy_INCLUDE_DIRS})
   SET(SOURCE_PYTHON ${PROJECT_SOURCE_DIR}/StOpt/python)
   IF(CMAKE_SYSTEM_NAME MATCHES "Windows")
     SET(PYTHON_SUFFIX ".pyd")
@@ -260,11 +259,11 @@
     ELSE()
       
       ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
-      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${PYTHON_LIBRARIES})
+      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
       SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")
 
       ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
-      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${PYTHON_LIBRARIES})
+      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
       SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")
 
       ADD_LIBRARY(StOptTree  SHARED  ${SOURCE_PYTHON}/Pybind11StOptTree.cpp)

=== debian/changelog ===
stopt (5.0+dfsg-5) unstable; urgency=medium

  * Testing the macro __powerpc__ instead of __ppc64__ on ppc64el in order to
    exclude irrelevant tests, hereby accompanying the auto-upperlimit-python3
    transition

 -- Pierre Gruet <pgt@debian.org>  Mon, 28 Mar 2022 17:07:42 +0200

stopt (5.0+dfsg-4) unstable; urgency=medium

  * Omitting tests for American options in 3D and 4D on ppc64el

 -- Pierre Gruet <pgt@debian.org>  Thu, 24 Mar 2022 09:48:15 +0100

stopt (5.0+dfsg-3) unstable; urgency=medium

  * Decreasing accuracy requirements again for ppc64el failing test
  * Excluding testGridKernelRegression.py from autopkgtest, as it needs a
    number of simulations that is too high for 32-bit arches
  * Fixing issue linked to concurrent access to geners archives during the
    tests

 -- Pierre Gruet <pgt@debian.org>  Wed, 23 Mar 2022 23:05:33 +0100

stopt (5.0+dfsg-2) unstable; urgency=medium

  * Dealing with accuracy issue during the tests on ppc64el

 -- Pierre Gruet <pgt@debian.org>  Tue, 22 Mar 2022 12:35:07 +0100

stopt (5.0+dfsg-1) unstable; urgency=medium

  * New upstream version 5.0+dfsg

 -- Pierre Gruet <pgt@debian.org>  Mon, 21 Mar 2022 21:53:47 +0100

stopt (5.0~rc4+dfsg-1) experimental; urgency=medium

  * New upstream version 5.0~rc4+dfsg
  * Refreshing patches

 -- Pierre Gruet <pgt@debian.org>  Wed, 16 Mar 2022 16:48:37 +0100

stopt (5.0~rc3+dfsg-2) experimental; urgency=medium

  * Adding d/gbp.conf to handle the MUT package with gbp
  * Trying to use JacobiSVD instead of BDCSVD to run tests successfully on mips64el and mipsel

 -- Pierre Gruet <pgt@debian.org>  Tue, 15 Mar 2022 21:01:06 +0100

stopt (5.0~rc3+dfsg-1) experimental; urgency=medium

  * New upstream version 5.0~rc3+dfsg
  * Refreshing patches

 -- Pierre Gruet <pgt@debian.org>  Wed, 09 Mar 2022 10:52:36 +0100

stopt (5.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream version 5.0~rc2+dfsg
  * Refreshing patches

 -- Pierre Gruet <pgt@debian.org>  Fri, 25 Feb 2022 12:54:35 +0100

stopt (5.0~rc1+dfsg-4) experimental; urgency=medium

  * Fixing some more tests to avoid numerical errors

 -- Pierre Gruet <pgt@debian.org>  Fri, 25 Feb 2022 11:36:31 +0100

stopt (5.0~rc1+dfsg-3) experimental; urgency=medium

  * Reindexing geners files to run tests in parallel

 -- Pierre Gruet <pgt@debian.org>  Thu, 24 Feb 2022 22:20:30 +0100

stopt (5.0~rc1+dfsg-2) experimental; urgency=medium

  * Fixing precision issues in some tests
  * Reorganizing build-dependencies using -Arch and -Indep

 -- Pierre Gruet <pgt@debian.org>  Tue, 22 Feb 2022 21:03:55 +0100

stopt (5.0~rc1+dfsg-1) experimental; urgency=medium

  * New upstream version 5.0~rc1+dfsg
  * Refreshing patches
  * Bumping SONAME to libstopt.so.5
  * Reorganizing targets in d/rules, based on -indep and -arch
  * Alleviating override_dh_fixperms, less changes are needed now
  * Automatically getting the version from DEB_VERSION_UPSTREAM in d/rules

 -- Pierre Gruet <pgt@debian.org>  Mon, 21 Feb 2022 22:32:10 +0100

=== debian/control ===
--- 
+++ 
@@ -5,39 +5,39 @@
 Section: math
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               cmake,
-               coinor-libcoinutils-dev,
-               coinor-libosi-dev,
-               coinor-libclp-dev,
                dh-python,
-               libboost-chrono-dev,
-               libboost-log-dev,
-               libboost-mpi-dev,
-               libboost-random-dev,
-               libboost-serialization-dev,
-               libboost-system-dev,
-               libboost-test-dev,
-               libboost-thread-dev,
-               libboost-timer-dev,
-               libeigen3-dev,
-               libopenmpi-dev,
-               libgeners-dev,
-               pybind11-dev,
-               python3-all-dev,
-               python3-docutils,
-               python3-numpy,
-               texlive-fonts-extra <!nodoc>,
-               texlive-latex-recommended <!nodoc>,
-               texlive-plain-generic <!nodoc>,
-               texlive-pstricks <!nodoc>,
-               texlive-science <!nodoc>
+Build-Depends-Arch: cmake,
+                    coinor-libcoinutils-dev,
+                    coinor-libosi-dev,
+                    coinor-libclp-dev,
+                    libboost-chrono-dev,
+                    libboost-log-dev,
+                    libboost-mpi-dev,
+                    libboost-random-dev,
+                    libboost-serialization-dev,
+                    libboost-system-dev,
+                    libboost-test-dev,
+                    libboost-thread-dev,
+                    libboost-timer-dev,
+                    libeigen3-dev,
+                    libopenmpi-dev,
+                    libgeners-dev,
+                    pybind11-dev,
+                    python3-all-dev,
+                    python3-docutils,
+                    python3-numpy
+Build-Depends-Indep: texlive-fonts-extra <!nodoc>,
+                     texlive-latex-recommended <!nodoc>,
+                     texlive-plain-generic <!nodoc>,
+                     texlive-pstricks <!nodoc>,
+                     texlive-science <!nodoc>
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/math-team/stopt
 Vcs-Git: https://salsa.debian.org/math-team/stopt.git
 Homepage: https://gitlab.com/stochastic-control/StOpt/
 Rules-Requires-Root: no
 
-Package: libstopt4
+Package: libstopt5
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
@@ -77,7 +77,7 @@
 Package: libstopt-dev
 Architecture: any
 Section: libdevel
-Depends: libstopt4 (= ${binary:Version}),
+Depends: libstopt5 (= ${binary:Version}),
          coinor-libcoinutils-dev,
          coinor-libosi-dev,
          coinor-libclp-dev,
@@ -159,7 +159,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
-Suggests: libstopt4 (= ${binary:Version}),
+Suggests: libstopt5 (= ${binary:Version}),
           libstopt-dev (= ${binary:Version}),
           stopt-examples (= ${binary:Version}),
           python3-stopt (= ${binary:Version})

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND=-O3
export DEB_CXXFLAGS_MAINT_STRIP=-O2
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/pkg-info.mk

SOVERSION_STOPT=5
VERSION_STOPT=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -E 's/~rc[0-9]*// ; s/\+dfsg[0-9]*//')

%:
	dh $@ --with python3

override_dh_auto_clean:
	dh_auto_clean
	# Removing the build directory of the LaTeX documentation.
	-rm -rf texdocBuild/

override_dh_auto_configure-arch:
	dh_auto_configure -- \
	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
	        -DCMAKE_INSTALL_PREFIX="/usr" \
	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
	        -DVERSION_STOPT="$(VERSION_STOPT)" \

override_dh_auto_configure-indep:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# Building the LaTeX documentation.
	# Two sets of paths have to be changed because we used a MUT package.
	cp -a texdoc/ texdocBuild/
	cd texdocBuild && \
	        sed -i 's|../StOpt/StOpt/|../StOpt/|g' documentation.tex && \
	        sed -i 's|../StOpt/test/|../test/|g' documentation.tex && \
	        pdflatex documentation.tex && \
	        bibtex documentation.aux && \
	        pdflatex documentation.tex && \
	        pdflatex documentation.tex
endif

override_dh_installdocs-indep:
	dh_installdocs -i
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	mkdir -p debian/stopt-doc/usr/share/doc/stopt-doc/
	cp texdocBuild/documentation.pdf debian/stopt-doc/usr/share/doc/stopt-doc/
endif

override_dh_installexamples-indep:
	dh_installexamples -i
	cp -a test/python/ debian/stopt-examples/usr/share/doc/stopt-examples/examples/
	# Some Python tests cannot be run because we don't package all built .so...
	# some of them being designed for the tests only.
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/functional/
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/geners/testSomeBinaryArchiveStorage.py
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/global
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/sddp
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/tree

override_dh_fixperms-indep:
	dh_fixperms -i
	#Setting all Python scripts (that are shipped as examples) as being executable
	for F in $$(find debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/ -name "test*.py"); do \
	        chmod a+x $$F; \
	done

## stopt 5.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 # define StOpt versions
 SET(STOPT_MAJOR_VERSION 5)
-SET(STOPT_MINOR_VERSION 0)
+SET(STOPT_MINOR_VERSION 1)
 ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
 ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")

=== debian/changelog ===
stopt (5.1+dfsg-4) unstable; urgency=medium

  * Providing an empty override for dh_auto_test-indep so that tests are not
    run twice during a full build (Closes: #1015063)

 -- Pierre Gruet <pgt@debian.org>  Mon, 18 Jul 2022 23:08:07 +0200

stopt (5.1+dfsg-3) unstable; urgency=medium

  * Running the tests sequentially

 -- Pierre Gruet <pgt@debian.org>  Mon, 04 Jul 2022 09:40:03 +0200

stopt (5.1+dfsg-2) unstable; urgency=medium

  * Adding a patch from upstream to solve concurrency issues in tests

 -- Pierre Gruet <pgt@debian.org>  Fri, 01 Jul 2022 09:32:10 +0200

stopt (5.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.1+dfsg
  * Refreshing patches
  * Raising Standards version to 4.6.1 (no change)
  * Passing CMAKE_BUILD_RPATH_USE_ORIGIN=ON to CMake to enhance build
    reproducibility

 -- Pierre Gruet <pgt@debian.org>  Wed, 29 Jun 2022 10:47:51 +0200

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
                      texlive-plain-generic <!nodoc>,
                      texlive-pstricks <!nodoc>,
                      texlive-science <!nodoc>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/math-team/stopt
 Vcs-Git: https://salsa.debian.org/math-team/stopt.git
 Homepage: https://gitlab.com/stochastic-control/StOpt/

=== debian/rules ===
--- 
+++ 
@@ -26,8 +26,9 @@
 	dh_auto_configure -- \
 	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
 	        -DCMAKE_INSTALL_PREFIX="/usr" \
+	        -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
 	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
-	        -DVERSION_STOPT="$(VERSION_STOPT)" \
+	        -DVERSION_STOPT="$(VERSION_STOPT)"
 
 override_dh_auto_configure-indep:
 
@@ -44,6 +45,14 @@
 	        pdflatex documentation.tex && \
 	        pdflatex documentation.tex
 endif
+
+override_dh_auto_test-arch:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	dh_auto_test -a --no-parallel
+endif
+
+# No test to perform for the architecture-independent packages
+override_dh_auto_test-indep:
 
 override_dh_installdocs-indep:
 	dh_installdocs -i

## stopt 5.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 # define StOpt versions
 SET(STOPT_MAJOR_VERSION 5)
-SET(STOPT_MINOR_VERSION 1)
+SET(STOPT_MINOR_VERSION 2)
 ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
 ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")

=== debian/changelog ===
stopt (5.2+dfsg-1) unstable; urgency=medium

  * New upstream version 5.2+dfsg:
    - Fixing incompatibilities with numpy 1.24.1 (Closes: #1027207)
  * Refreshing patches
  * Raising Standards version to 4.6.2 (no change)
  * Set upstream metadata fields: Repository-Browse.

 -- Pierre Gruet <pgt@debian.org>  Fri, 06 Jan 2023 12:42:48 +0100

stopt (5.1+dfsg-6) unstable; urgency=medium

  * Build-depending on python3-dev instead of python3-all-dev
    (Closes: #1024315)
  * Passing Python3_ variables needed by CMake via d/rules instead of defining
    them through the CMake find_package mechanism to avoid errors when multiple
    versions of Python3 are installed together

 -- Pierre Gruet <pgt@debian.org>  Fri, 18 Nov 2022 23:35:40 +0100

stopt (5.1+dfsg-5) unstable; urgency=medium

  * Omitting to run tests on 4 and 8 cores on mipsel as it causes freezes on
    the Debian buildds

 -- Pierre Gruet <pgt@debian.org>  Tue, 26 Jul 2022 20:54:48 +0200

## stopt 5.5%2Bdfsg

=== debian/changelog ===
stopt (5.5+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports

 -- Pierre Gruet <pgt@debian.org>  Wed, 08 Mar 2023 15:56:48 +0100

stopt (5.5+dfsg-1) unstable; urgency=medium

  * New upstream version 5.5+dfsg

 -- Pierre Gruet <pgt@debian.org>  Sun, 29 Jan 2023 15:03:03 +0100

stopt (5.4+dfsg-1~exp0) experimental; urgency=medium

  * New upstream version 5.4+dfsg

 -- Pierre Gruet <pgt@debian.org>  Sun, 22 Jan 2023 10:38:32 +0100

stopt (5.3+dfsg-1~exp0) experimental; urgency=medium

  * New upstream version 5.3+dfsg
  * Refreshing patches
  * Stopping substituting quotes with angle brackets in #include directives
    for geners

 -- Pierre Gruet <pgt@debian.org>  Thu, 19 Jan 2023 06:58:45 +0100

## stopt 5.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 # define StOpt versions
 SET(STOPT_MAJOR_VERSION 5)
-SET(STOPT_MINOR_VERSION 2)
+SET(STOPT_MINOR_VERSION 5)
 ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
 ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
                     libopenmpi-dev,
                     libgeners-dev,
                     pybind11-dev,
-                    python3-all-dev,
+                    python3-dev,
                     python3-docutils,
                     python3-numpy
 Build-Depends-Indep: texlive-fonts-extra <!nodoc>,
@@ -31,7 +31,7 @@
                      texlive-plain-generic <!nodoc>,
                      texlive-pstricks <!nodoc>,
                      texlive-science <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/math-team/stopt
 Vcs-Git: https://salsa.debian.org/math-team/stopt.git
 Homepage: https://gitlab.com/stochastic-control/StOpt/

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,8 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 include /usr/share/dpkg/pkg-info.mk
+
+PY3VER=$(shell py3versions -d)
 
 SOVERSION_STOPT=5
 VERSION_STOPT=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -E 's/~rc[0-9]*// ; s/\+dfsg[0-9]*//')
@@ -28,7 +30,10 @@
 	        -DCMAKE_INSTALL_PREFIX="/usr" \
 	        -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
 	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
-	        -DVERSION_STOPT="$(VERSION_STOPT)"
+	        -DVERSION_STOPT="$(VERSION_STOPT)" \
+	        -DPython3_INCLUDE_DIRS=$(shell python3-config --includes | sed 's/.*-I//') \
+	        -DPython3_LIBRARIES=$(shell ls /usr/lib/$(DEB_HOST_MULTIARCH)/libpython*.so | grep "$(PY3VER)") \
+	        -DPython3_NumPy_INCLUDE_DIRS=/usr/lib/python3/dist-packages/numpy/core/include
 
 override_dh_auto_configure-indep:
 
@@ -48,7 +53,13 @@
 
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+# Disabling tests with 4 or 8 cores on mipsel as it causes freezes and thus
+# failures on the buildds.
+ifeq ($(shell dpkg --print-architecture),mipsel)
+	dh_auto_test -a --no-parallel -- ARGS+='-E "(4|8)core"'
+else
 	dh_auto_test -a --no-parallel
+endif
 endif
 
 # No test to perform for the architecture-independent packages

## stopt 5.7+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 # define StOpt versions
 SET(STOPT_MAJOR_VERSION 5)
-SET(STOPT_MINOR_VERSION 5)
+SET(STOPT_MINOR_VERSION 7)
 ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
 ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")

=== debian/changelog ===
stopt (5.7+dfsg-1) unstable; urgency=medium

  * New upstream version 5.7+dfsg

 -- Pierre Gruet <pgt@debian.org>  Mon, 26 Jun 2023 11:47:06 +0200

## stopt 5.8+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 # define StOpt versions
 SET(STOPT_MAJOR_VERSION 5)
-SET(STOPT_MINOR_VERSION 7)
+SET(STOPT_MINOR_VERSION 8)
 ADD_DEFINITIONS("-DSTOPT_MAJOR_VERSION=${STOPT_MAJOR_VERSION}")
 ADD_DEFINITIONS("-DSTOPT_MINOR_VERSION=${STOPT_MINOR_VERSION}")

=== debian/changelog ===
stopt (5.8+dfsg-1.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:55:16 +1100

stopt (5.8+dfsg-1.1build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@debian.org>  Sat, 02 Mar 2024 21:22:18 +0100

stopt (5.8+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062931

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:38:41 +0000

stopt (5.8+dfsg-1) unstable; urgency=medium

  * New upstream version 5.8+dfsg
  * Removing mipsel-related treatments in d/rules, as mipsel is not a
    supported architecture anymore

 -- Pierre Gruet <pgt@debian.org>  Fri, 13 Oct 2023 16:48:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: stopt
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Pierre Gruet <pgt@debian.org>,
            Xavier Warin <xavier.warin@gmail.com>
 Section: math
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                dh-python,
-Build-Depends-Arch: cmake,
+Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
                     coinor-libcoinutils-dev,
                     coinor-libosi-dev,
                     coinor-libclp-dev,
@@ -37,7 +38,10 @@
 Homepage: https://gitlab.com/stochastic-control/StOpt/
 Rules-Requires-Root: no
 
-Package: libstopt5
+Package: libstopt5t64
+Provides: ${t64:Provides}
+Replaces: libstopt5
+Breaks: libstopt5 (<< ${source:Version})
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
@@ -77,7 +81,7 @@
 Package: libstopt-dev
 Architecture: any
 Section: libdevel
-Depends: libstopt5 (= ${binary:Version}),
+Depends: libstopt5t64 (= ${binary:Version}),
          coinor-libcoinutils-dev,
          coinor-libosi-dev,
          coinor-libclp-dev,
@@ -159,7 +163,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
-Suggests: libstopt5 (= ${binary:Version}),
+Suggests: libstopt5t64 (= ${binary:Version}),
           libstopt-dev (= ${binary:Version}),
           stopt-examples (= ${binary:Version}),
           python3-stopt (= ${binary:Version})

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,14 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# If noopt was not passed, building with -O3 instead of -O2 to enhance
+# numerical performance.
+ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
 export DEB_CXXFLAGS_MAINT_APPEND=-O3
 export DEB_CXXFLAGS_MAINT_STRIP=-O2
+endif
+
 include /usr/share/dpkg/buildflags.mk
 CFLAGS+=$(CPPFLAGS)
 CXXFLAGS+=$(CPPFLAGS)
@@ -51,15 +57,10 @@
 	        pdflatex documentation.tex
 endif
 
+# Tests cannot be run safely in parallel.
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-# Disabling tests with 4 or 8 cores on mipsel as it causes freezes and thus
-# failures on the buildds.
-ifeq ($(shell dpkg --print-architecture),mipsel)
-	dh_auto_test -a --no-parallel -- ARGS+='-E "(4|8)core"'
-else
 	dh_auto_test -a --no-parallel
-endif
 endif
 
 # No test to perform for the architecture-independent packages

=== debian/watch ===
version=4

opts="dversionmangle=s/\+dfsg\d*//,oversionmangle=s/(.*)/$1+dfsg/" \
  https://gitlab.com/stochastic-control/StOpt/tags \
  (?:.*/)StOpt-v@ANY_VERSION@\.tar\.gz debian

opts="component=texdoc" \
  https://gitlab.com/stochastic-control/StOptDoc/tags \
  (?:.*/)StOptDoc-v@ANY_VERSION@\.tar\.gz \
  ignore

## stopt 5.12%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: stopt
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Pierre Gruet <pgt@debian.org>,
            Xavier Warin <xavier.warin@gmail.com>
 Section: math
 Priority: optional
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                dh-python,
-Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
+Build-Depends-Arch: cmake,
                     coinor-libcoinutils-dev,
                     coinor-libosi-dev,
                     coinor-libclp-dev,
@@ -21,8 +20,8 @@
                     libboost-thread-dev,
                     libboost-timer-dev,
                     libeigen3-dev,
-                    libopenmpi-dev,
                     libgeners-dev,
+                    mpi-default-dev,
                     pybind11-dev,
                     python3-dev,
                     python3-docutils,
@@ -32,7 +31,7 @@
                      texlive-plain-generic <!nodoc>,
                      texlive-pstricks <!nodoc>,
                      texlive-science <!nodoc>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/math-team/stopt
 Vcs-Git: https://salsa.debian.org/math-team/stopt.git
 Homepage: https://gitlab.com/stochastic-control/StOpt/
@@ -96,7 +95,7 @@
          libboost-timer-dev,
          libeigen3-dev,
          libgeners-dev,
-         libopenmpi-dev,
+         mpi-default-dev,
          ${misc:Depends}
 Suggests: stopt-doc (= ${binary:Version})
 Description: library for stochastic optimization problems (development package)
